# Netzwerk im [Zentralwerk](http://www.zentralwerk.de/)

## Zweck

Das Zentralwerk ist ein Gebäude, das bestmöglich vernetzt sein soll. Das beginnt mit der Bereitstellung vom Zugang zum Internet, reicht über das isolierte Zusammenführen von einzelnen Anschlüssen und endet mit Angebot von zeitgemäßen Diensten für alle, die das Netz nutzen wollen.

Anstatt irgendwie rumzukonfigurieren, soll es eine Nachvollziehbarkeit (Reproduzierbarkeit) der gemachten Einstellungen geben.
Mit der Transparenz soll es möglich sein, dass das Netzwerk möglichst einfach verwaltet werden kann. (Stichworte sind: Zusammenarbeit, Wiederherstellbarkeit, Teilhabe, Mitmachen, Nachahmen, …)

## allgemeine Informationen

### Informationen für Menschen, die angeschlossen werden möchten

[Begrüßung von Menschen im Haus, die für ihren Anschluss Zugang zum Netzwerk brauchen](doc/hello.md)

### Informationen für Menschen, die das Netzwerk mit verwalten

#### Inhaltsverzeichnis

* [Verkabelung Patchpanel Haus B](cabling.md)
* [Planung der IP-Adressbereiche](subnets.md)
* (verschlüsselte) [Kontakte zu den Personen mit den einzelnen Anschlüssen](contact.md.gpg)
* Dokumentation
  * [WiFi-Provisionierung](doc/wifi-provisioning.md) und Erstellung von Privatnetzen
  * [Einrichtung einer Testumgebung fürs Mit- und Nachmachen (Entwicklung)](doc/test-environment.md)
* Unterverzeichnis [salt/](salt): Skripte (*salt states*) zum Aufbau des zentralen Services
* Unterverzeichnis [salt-pillar/](salt-pillar): individuelle Konfigurationsdaten
  * **vlans** bildet Netznamen auf VLAN-IDs ab
  * **subnets** und ../subnets.md enthält unsere IP-Netzplanung
  * **hosts** sind alle statisch konfigurierten IP-Adressen
  * **dhcp** enthält die zur Verfügung gestellten privaten Addressbereiche
  * **switches** dient zur Konfigurationserzeugung für alle Managed Switches
  * **cpe** sind Daten für Konfiguration des *Customer Premise Equipment* (WiFi Access Points)
* Datei top.sls listet die auf einzelnen Containern und im Host verwendeten Systemdienste

#### Dinge die stets schieflaufen

##### `salt server1 state.apply server1-network`

Hier werden die Bridges abgerissen und neu erstellt. Danach hängen
gestartete lxc-Container nicht mehr dran.

**Lösung:** Manuell hinzufügen mit `brctl addif` oder einfach die
Container neustarten.

##### Switch-Konfigurationsskripte ausgeführt, dabei ist das Netz gestorben

Das tritt auf wenn man so doll die Konfiguration verändert, dass die
Nummern der Link-Aggregation Groups sich ändern. Dabei landet server1,
von welchem gerade konfiguriert wird, temporär in einer Gruppe die
eigentlich zu was anderem gehört.

**Lösung:** Skript auf eigenen Computer kopieren, direkt ans *mgmt*
hängen und ausführen.

##### pub-Netz läuft, aber kein DHCP+Internet darüber verfügbar

Eventuell hat `uci` bei der ap-Konfiguration die Switch-Konfiguration
für dieses VLAN nicht in `/etc/config/network` angelegt.

* **Überprüfen**: `swconfig dev switch0 show`
* **Beheben**: VLAN manuell in `/etc/config/network` anelegen

## Öffentlichkeit

Warum ist das alles einsehbar? Für maximale Transparenz!
Wir sind kein Unternehmen das Geheimnisse schützen muss. Stattdessen wollen wir freie Kommunikation für alle!

Wie werden die (wenigen) persönlichen Daten "öffentlich" verwaltet? Mit entsprechender Verschlüsselung!
Wir, ein kleiner Kreis von Menschen die das Netzwerk im Zentralwerk betreuen, haben dafür einen Geheimschlüssel. Im Übrigen behandeln wir gleichermaßen sicher die "heiligen" Zugangsdaten für die Geräte (und andere für den Betrieb wichtigen Instanzen).

## System

Verkabelung
  * im Haus
  * in Serverschränken

Server (Hardware)
  * Bebriebssystem: Debian (GNU/Linux)
  * Verwaltung der Konfiguration:
    * [salt](https://www.saltstack.com/)
    * Repository
    * (generierte) Skripte
  * Container: LXC
    * Dienst DHCP:
    * Dienst DNS:
    * …

Geräte für die Verteilung vom Netzwerk
  * Switches (bis zu den Anschlüssen)
  * Access Points (hinter den Anschlüssen)

Zugänge fürs Internet
  * bezogene Anschlüsse bei anbietenden Unternehmen
  * bezogener Zugang zu einem VPN bei anbietenden Unternehmen

Randbedingungen:
  * Server (Hardware)
    * Betriebssystem: Proxmox VE (als kleines Cluster, auch für Dienste)

## Zukunft

#### Einsatz von NixOS auf dem Server

Mittelfristig soll das System bestmöglich mit NixOS betrieben werden. Entsprechend würde dann Debian und (mindestens Großteile) von salt ersetzt werden.

Mit NixOS wäre eine bessere (absolutere) Kontrolle möglich. Die Konfiguration wird nicht komplizierter.
