{ hostName, config, lib, pkgs, ... }:

let
  inherit (lib) optionals;

  hostConfig = lib.config.site.hosts.${hostName};
in {
  site = lib.config.site;

  imports = [
    ./defaults.nix
    ../lib/config/options.nix
  ]
  ++ optionals (hostConfig.role == "server") [
    ./lxc-containers.nix
  ]
  ++ optionals (hostConfig.role == "container") [
    ./container.nix
  ];
}
